// new_core.v

// Generated using ACDS version 20.1 720

`timescale 1 ps / 1 ps
module new_core (
		input  wire        clk_clk,                               //                          clk.clk
		input  wire        reset_reset_n,                         //                        reset.reset_n
		input  wire [2:0]  switches_external_connection_export,   // switches_external_connection.export
		input  wire        vga_out_clocked_video_vid_clk,         //        vga_out_clocked_video.vid_clk
		output wire [11:0] vga_out_clocked_video_vid_data,        //                             .vid_data
		output wire        vga_out_clocked_video_underflow,       //                             .underflow
		output wire        vga_out_clocked_video_vid_mode_change, //                             .vid_mode_change
		output wire        vga_out_clocked_video_vid_std,         //                             .vid_std
		output wire        vga_out_clocked_video_vid_datavalid,   //                             .vid_datavalid
		output wire        vga_out_clocked_video_vid_v_sync,      //                             .vid_v_sync
		output wire        vga_out_clocked_video_vid_h_sync,      //                             .vid_h_sync
		output wire        vga_out_clocked_video_vid_f,           //                             .vid_f
		output wire        vga_out_clocked_video_vid_h,           //                             .vid_h
		output wire        vga_out_clocked_video_vid_v            //                             .vid_v
	);

	wire         test_pattern_dout_valid;                                   // test_pattern:dout_valid -> vga_out:din_valid
	wire  [11:0] test_pattern_dout_data;                                    // test_pattern:dout_data -> vga_out:din_data
	wire         test_pattern_dout_ready;                                   // vga_out:din_ready -> test_pattern:dout_ready
	wire         test_pattern_dout_startofpacket;                           // test_pattern:dout_startofpacket -> vga_out:din_startofpacket
	wire         test_pattern_dout_endofpacket;                             // test_pattern:dout_endofpacket -> vga_out:din_endofpacket
	wire  [31:0] cpu_data_master_readdata;                                  // mm_interconnect_0:CPU_data_master_readdata -> CPU:d_readdata
	wire         cpu_data_master_waitrequest;                               // mm_interconnect_0:CPU_data_master_waitrequest -> CPU:d_waitrequest
	wire         cpu_data_master_debugaccess;                               // CPU:debug_mem_slave_debugaccess_to_roms -> mm_interconnect_0:CPU_data_master_debugaccess
	wire  [18:0] cpu_data_master_address;                                   // CPU:d_address -> mm_interconnect_0:CPU_data_master_address
	wire   [3:0] cpu_data_master_byteenable;                                // CPU:d_byteenable -> mm_interconnect_0:CPU_data_master_byteenable
	wire         cpu_data_master_read;                                      // CPU:d_read -> mm_interconnect_0:CPU_data_master_read
	wire         cpu_data_master_write;                                     // CPU:d_write -> mm_interconnect_0:CPU_data_master_write
	wire  [31:0] cpu_data_master_writedata;                                 // CPU:d_writedata -> mm_interconnect_0:CPU_data_master_writedata
	wire  [31:0] cpu_instruction_master_readdata;                           // mm_interconnect_0:CPU_instruction_master_readdata -> CPU:i_readdata
	wire         cpu_instruction_master_waitrequest;                        // mm_interconnect_0:CPU_instruction_master_waitrequest -> CPU:i_waitrequest
	wire  [18:0] cpu_instruction_master_address;                            // CPU:i_address -> mm_interconnect_0:CPU_instruction_master_address
	wire         cpu_instruction_master_read;                               // CPU:i_read -> mm_interconnect_0:CPU_instruction_master_read
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect;  // mm_interconnect_0:jtag_uart_avalon_jtag_slave_chipselect -> jtag_uart:av_chipselect
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata;    // jtag_uart:av_readdata -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_readdata
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest; // jtag_uart:av_waitrequest -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_waitrequest
	wire   [0:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_address;     // mm_interconnect_0:jtag_uart_avalon_jtag_slave_address -> jtag_uart:av_address
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;        // mm_interconnect_0:jtag_uart_avalon_jtag_slave_read -> jtag_uart:av_read_n
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;       // mm_interconnect_0:jtag_uart_avalon_jtag_slave_write -> jtag_uart:av_write_n
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata;   // mm_interconnect_0:jtag_uart_avalon_jtag_slave_writedata -> jtag_uart:av_writedata
	wire  [31:0] mm_interconnect_0_test_pattern_control_readdata;           // test_pattern:control_readdata -> mm_interconnect_0:test_pattern_control_readdata
	wire         mm_interconnect_0_test_pattern_control_waitrequest;        // test_pattern:control_waitrequest -> mm_interconnect_0:test_pattern_control_waitrequest
	wire   [3:0] mm_interconnect_0_test_pattern_control_address;            // mm_interconnect_0:test_pattern_control_address -> test_pattern:control_address
	wire         mm_interconnect_0_test_pattern_control_read;               // mm_interconnect_0:test_pattern_control_read -> test_pattern:control_read
	wire   [3:0] mm_interconnect_0_test_pattern_control_byteenable;         // mm_interconnect_0:test_pattern_control_byteenable -> test_pattern:control_byteenable
	wire         mm_interconnect_0_test_pattern_control_readdatavalid;      // test_pattern:control_readdatavalid -> mm_interconnect_0:test_pattern_control_readdatavalid
	wire         mm_interconnect_0_test_pattern_control_write;              // mm_interconnect_0:test_pattern_control_write -> test_pattern:control_write
	wire  [31:0] mm_interconnect_0_test_pattern_control_writedata;          // mm_interconnect_0:test_pattern_control_writedata -> test_pattern:control_writedata
	wire  [31:0] mm_interconnect_0_vga_out_control_readdata;                // vga_out:control_readdata -> mm_interconnect_0:vga_out_control_readdata
	wire         mm_interconnect_0_vga_out_control_waitrequest;             // vga_out:control_waitrequest -> mm_interconnect_0:vga_out_control_waitrequest
	wire   [7:0] mm_interconnect_0_vga_out_control_address;                 // mm_interconnect_0:vga_out_control_address -> vga_out:control_address
	wire         mm_interconnect_0_vga_out_control_read;                    // mm_interconnect_0:vga_out_control_read -> vga_out:control_read
	wire   [3:0] mm_interconnect_0_vga_out_control_byteenable;              // mm_interconnect_0:vga_out_control_byteenable -> vga_out:control_byteenable
	wire         mm_interconnect_0_vga_out_control_readdatavalid;           // vga_out:control_readdatavalid -> mm_interconnect_0:vga_out_control_readdatavalid
	wire         mm_interconnect_0_vga_out_control_write;                   // mm_interconnect_0:vga_out_control_write -> vga_out:control_write
	wire  [31:0] mm_interconnect_0_vga_out_control_writedata;               // mm_interconnect_0:vga_out_control_writedata -> vga_out:control_writedata
	wire  [31:0] mm_interconnect_0_sysid_control_slave_readdata;            // sysid:readdata -> mm_interconnect_0:sysid_control_slave_readdata
	wire   [0:0] mm_interconnect_0_sysid_control_slave_address;             // mm_interconnect_0:sysid_control_slave_address -> sysid:address
	wire  [31:0] mm_interconnect_0_cpu_debug_mem_slave_readdata;            // CPU:debug_mem_slave_readdata -> mm_interconnect_0:CPU_debug_mem_slave_readdata
	wire         mm_interconnect_0_cpu_debug_mem_slave_waitrequest;         // CPU:debug_mem_slave_waitrequest -> mm_interconnect_0:CPU_debug_mem_slave_waitrequest
	wire         mm_interconnect_0_cpu_debug_mem_slave_debugaccess;         // mm_interconnect_0:CPU_debug_mem_slave_debugaccess -> CPU:debug_mem_slave_debugaccess
	wire   [8:0] mm_interconnect_0_cpu_debug_mem_slave_address;             // mm_interconnect_0:CPU_debug_mem_slave_address -> CPU:debug_mem_slave_address
	wire         mm_interconnect_0_cpu_debug_mem_slave_read;                // mm_interconnect_0:CPU_debug_mem_slave_read -> CPU:debug_mem_slave_read
	wire   [3:0] mm_interconnect_0_cpu_debug_mem_slave_byteenable;          // mm_interconnect_0:CPU_debug_mem_slave_byteenable -> CPU:debug_mem_slave_byteenable
	wire         mm_interconnect_0_cpu_debug_mem_slave_write;               // mm_interconnect_0:CPU_debug_mem_slave_write -> CPU:debug_mem_slave_write
	wire  [31:0] mm_interconnect_0_cpu_debug_mem_slave_writedata;           // mm_interconnect_0:CPU_debug_mem_slave_writedata -> CPU:debug_mem_slave_writedata
	wire         mm_interconnect_0_code_memory_s1_chipselect;               // mm_interconnect_0:code_memory_s1_chipselect -> code_memory:chipselect
	wire  [31:0] mm_interconnect_0_code_memory_s1_readdata;                 // code_memory:readdata -> mm_interconnect_0:code_memory_s1_readdata
	wire  [14:0] mm_interconnect_0_code_memory_s1_address;                  // mm_interconnect_0:code_memory_s1_address -> code_memory:address
	wire   [3:0] mm_interconnect_0_code_memory_s1_byteenable;               // mm_interconnect_0:code_memory_s1_byteenable -> code_memory:byteenable
	wire         mm_interconnect_0_code_memory_s1_write;                    // mm_interconnect_0:code_memory_s1_write -> code_memory:write
	wire  [31:0] mm_interconnect_0_code_memory_s1_writedata;                // mm_interconnect_0:code_memory_s1_writedata -> code_memory:writedata
	wire         mm_interconnect_0_code_memory_s1_clken;                    // mm_interconnect_0:code_memory_s1_clken -> code_memory:clken
	wire         mm_interconnect_0_sys_clk_timer_s1_chipselect;             // mm_interconnect_0:sys_clk_timer_s1_chipselect -> sys_clk_timer:chipselect
	wire  [15:0] mm_interconnect_0_sys_clk_timer_s1_readdata;               // sys_clk_timer:readdata -> mm_interconnect_0:sys_clk_timer_s1_readdata
	wire   [2:0] mm_interconnect_0_sys_clk_timer_s1_address;                // mm_interconnect_0:sys_clk_timer_s1_address -> sys_clk_timer:address
	wire         mm_interconnect_0_sys_clk_timer_s1_write;                  // mm_interconnect_0:sys_clk_timer_s1_write -> sys_clk_timer:write_n
	wire  [15:0] mm_interconnect_0_sys_clk_timer_s1_writedata;              // mm_interconnect_0:sys_clk_timer_s1_writedata -> sys_clk_timer:writedata
	wire  [31:0] mm_interconnect_0_switches_s1_readdata;                    // switches:readdata -> mm_interconnect_0:switches_s1_readdata
	wire   [1:0] mm_interconnect_0_switches_s1_address;                     // mm_interconnect_0:switches_s1_address -> switches:address
	wire         irq_mapper_receiver0_irq;                                  // jtag_uart:av_irq -> irq_mapper:receiver0_irq
	wire         irq_mapper_receiver1_irq;                                  // sys_clk_timer:irq -> irq_mapper:receiver1_irq
	wire         irq_mapper_receiver2_irq;                                  // vga_out:status_update_irq_irq -> irq_mapper:receiver2_irq
	wire  [31:0] cpu_irq_irq;                                               // irq_mapper:sender_irq -> CPU:irq
	wire         rst_controller_reset_out_reset;                            // rst_controller:reset_out -> [CPU:reset_n, code_memory:reset, irq_mapper:reset, jtag_uart:rst_n, mm_interconnect_0:CPU_reset_reset_bridge_in_reset_reset, rst_translator:in_reset, switches:reset_n, sys_clk_timer:reset_n, sysid:reset_n, test_pattern:main_reset, vga_out:main_reset_reset]
	wire         rst_controller_reset_out_reset_req;                        // rst_controller:reset_req -> [CPU:reset_req, code_memory:reset_req, rst_translator:reset_req_in]

	new_core_CPU cpu (
		.clk                                 (clk_clk),                                           //                       clk.clk
		.reset_n                             (~rst_controller_reset_out_reset),                   //                     reset.reset_n
		.reset_req                           (rst_controller_reset_out_reset_req),                //                          .reset_req
		.d_address                           (cpu_data_master_address),                           //               data_master.address
		.d_byteenable                        (cpu_data_master_byteenable),                        //                          .byteenable
		.d_read                              (cpu_data_master_read),                              //                          .read
		.d_readdata                          (cpu_data_master_readdata),                          //                          .readdata
		.d_waitrequest                       (cpu_data_master_waitrequest),                       //                          .waitrequest
		.d_write                             (cpu_data_master_write),                             //                          .write
		.d_writedata                         (cpu_data_master_writedata),                         //                          .writedata
		.debug_mem_slave_debugaccess_to_roms (cpu_data_master_debugaccess),                       //                          .debugaccess
		.i_address                           (cpu_instruction_master_address),                    //        instruction_master.address
		.i_read                              (cpu_instruction_master_read),                       //                          .read
		.i_readdata                          (cpu_instruction_master_readdata),                   //                          .readdata
		.i_waitrequest                       (cpu_instruction_master_waitrequest),                //                          .waitrequest
		.irq                                 (cpu_irq_irq),                                       //                       irq.irq
		.debug_reset_request                 (),                                                  //       debug_reset_request.reset
		.debug_mem_slave_address             (mm_interconnect_0_cpu_debug_mem_slave_address),     //           debug_mem_slave.address
		.debug_mem_slave_byteenable          (mm_interconnect_0_cpu_debug_mem_slave_byteenable),  //                          .byteenable
		.debug_mem_slave_debugaccess         (mm_interconnect_0_cpu_debug_mem_slave_debugaccess), //                          .debugaccess
		.debug_mem_slave_read                (mm_interconnect_0_cpu_debug_mem_slave_read),        //                          .read
		.debug_mem_slave_readdata            (mm_interconnect_0_cpu_debug_mem_slave_readdata),    //                          .readdata
		.debug_mem_slave_waitrequest         (mm_interconnect_0_cpu_debug_mem_slave_waitrequest), //                          .waitrequest
		.debug_mem_slave_write               (mm_interconnect_0_cpu_debug_mem_slave_write),       //                          .write
		.debug_mem_slave_writedata           (mm_interconnect_0_cpu_debug_mem_slave_writedata),   //                          .writedata
		.dummy_ci_port                       ()                                                   // custom_instruction_master.readra
	);

	new_core_code_memory code_memory (
		.clk        (clk_clk),                                     //   clk1.clk
		.address    (mm_interconnect_0_code_memory_s1_address),    //     s1.address
		.clken      (mm_interconnect_0_code_memory_s1_clken),      //       .clken
		.chipselect (mm_interconnect_0_code_memory_s1_chipselect), //       .chipselect
		.write      (mm_interconnect_0_code_memory_s1_write),      //       .write
		.readdata   (mm_interconnect_0_code_memory_s1_readdata),   //       .readdata
		.writedata  (mm_interconnect_0_code_memory_s1_writedata),  //       .writedata
		.byteenable (mm_interconnect_0_code_memory_s1_byteenable), //       .byteenable
		.reset      (rst_controller_reset_out_reset),              // reset1.reset
		.reset_req  (rst_controller_reset_out_reset_req),          //       .reset_req
		.freeze     (1'b0)                                         // (terminated)
	);

	new_core_jtag_uart jtag_uart (
		.clk            (clk_clk),                                                   //               clk.clk
		.rst_n          (~rst_controller_reset_out_reset),                           //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_mapper_receiver0_irq)                                   //               irq.irq
	);

	new_core_switches switches (
		.clk      (clk_clk),                                //                 clk.clk
		.reset_n  (~rst_controller_reset_out_reset),        //               reset.reset_n
		.address  (mm_interconnect_0_switches_s1_address),  //                  s1.address
		.readdata (mm_interconnect_0_switches_s1_readdata), //                    .readdata
		.in_port  (switches_external_connection_export)     // external_connection.export
	);

	new_core_sys_clk_timer sys_clk_timer (
		.clk        (clk_clk),                                       //   clk.clk
		.reset_n    (~rst_controller_reset_out_reset),               // reset.reset_n
		.address    (mm_interconnect_0_sys_clk_timer_s1_address),    //    s1.address
		.writedata  (mm_interconnect_0_sys_clk_timer_s1_writedata),  //      .writedata
		.readdata   (mm_interconnect_0_sys_clk_timer_s1_readdata),   //      .readdata
		.chipselect (mm_interconnect_0_sys_clk_timer_s1_chipselect), //      .chipselect
		.write_n    (~mm_interconnect_0_sys_clk_timer_s1_write),     //      .write_n
		.irq        (irq_mapper_receiver1_irq)                       //   irq.irq
	);

	new_core_sysid sysid (
		.clock    (clk_clk),                                        //           clk.clk
		.reset_n  (~rst_controller_reset_out_reset),                //         reset.reset_n
		.readdata (mm_interconnect_0_sysid_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_0_sysid_control_slave_address)   //              .address
	);

	new_core_test_pattern #(
		.PIXELS_IN_PARALLEL (1)
	) test_pattern (
		.main_clock            (clk_clk),                                              // main_clock.clk
		.main_reset            (rst_controller_reset_out_reset),                       // main_reset.reset
		.dout_data             (test_pattern_dout_data),                               //       dout.data
		.dout_valid            (test_pattern_dout_valid),                              //           .valid
		.dout_startofpacket    (test_pattern_dout_startofpacket),                      //           .startofpacket
		.dout_endofpacket      (test_pattern_dout_endofpacket),                        //           .endofpacket
		.dout_ready            (test_pattern_dout_ready),                              //           .ready
		.control_address       (mm_interconnect_0_test_pattern_control_address),       //    control.address
		.control_byteenable    (mm_interconnect_0_test_pattern_control_byteenable),    //           .byteenable
		.control_write         (mm_interconnect_0_test_pattern_control_write),         //           .write
		.control_writedata     (mm_interconnect_0_test_pattern_control_writedata),     //           .writedata
		.control_read          (mm_interconnect_0_test_pattern_control_read),          //           .read
		.control_readdata      (mm_interconnect_0_test_pattern_control_readdata),      //           .readdata
		.control_readdatavalid (mm_interconnect_0_test_pattern_control_readdatavalid), //           .readdatavalid
		.control_waitrequest   (mm_interconnect_0_test_pattern_control_waitrequest)    //           .waitrequest
	);

	new_core_vga_out #(
		.BPS                           (4),
		.NUMBER_OF_COLOUR_PLANES       (3),
		.COLOUR_PLANES_ARE_IN_PARALLEL (1),
		.INTERLACED                    (0),
		.H_ACTIVE_PIXELS               (640),
		.V_ACTIVE_LINES                (480),
		.ACCEPT_COLOURS_IN_SEQ         (0),
		.FIFO_DEPTH                    (640),
		.CLOCKS_ARE_SAME               (0),
		.USE_CONTROL                   (1),
		.NO_OF_MODES                   (1),
		.THRESHOLD                     (639),
		.STD_WIDTH                     (1),
		.GENERATE_SYNC                 (0),
		.ACCEPT_SYNC                   (0),
		.COUNT_STEP_IS_PIP_VALUE       (0),
		.LOW_LATENCY                   (0),
		.USE_EMBEDDED_SYNCS            (0),
		.AP_LINE                       (0),
		.V_BLANK                       (0),
		.H_BLANK                       (0),
		.H_SYNC_LENGTH                 (96),
		.H_FRONT_PORCH                 (16),
		.H_BACK_PORCH                  (48),
		.V_SYNC_LENGTH                 (2),
		.V_FRONT_PORCH                 (10),
		.V_BACK_PORCH                  (33),
		.F_RISING_EDGE                 (0),
		.F_FALLING_EDGE                (0),
		.FIELD0_V_RISING_EDGE          (0),
		.FIELD0_V_BLANK                (0),
		.FIELD0_V_SYNC_LENGTH          (0),
		.FIELD0_V_FRONT_PORCH          (0),
		.FIELD0_V_BACK_PORCH           (0),
		.ANC_LINE                      (0),
		.FIELD0_ANC_LINE               (0),
		.PIXELS_IN_PARALLEL            (1),
		.SRC_WIDTH                     (8),
		.DST_WIDTH                     (8),
		.CONTEXT_WIDTH                 (8),
		.TASK_WIDTH                    (8)
	) vga_out (
		.clocked_video_vid_clk         (vga_out_clocked_video_vid_clk),                   //     clocked_video.vid_clk
		.clocked_video_vid_data        (vga_out_clocked_video_vid_data),                  //                  .vid_data
		.clocked_video_underflow       (vga_out_clocked_video_underflow),                 //                  .underflow
		.clocked_video_vid_mode_change (vga_out_clocked_video_vid_mode_change),           //                  .vid_mode_change
		.clocked_video_vid_std         (vga_out_clocked_video_vid_std),                   //                  .vid_std
		.clocked_video_vid_datavalid   (vga_out_clocked_video_vid_datavalid),             //                  .vid_datavalid
		.clocked_video_vid_v_sync      (vga_out_clocked_video_vid_v_sync),                //                  .vid_v_sync
		.clocked_video_vid_h_sync      (vga_out_clocked_video_vid_h_sync),                //                  .vid_h_sync
		.clocked_video_vid_f           (vga_out_clocked_video_vid_f),                     //                  .vid_f
		.clocked_video_vid_h           (vga_out_clocked_video_vid_h),                     //                  .vid_h
		.clocked_video_vid_v           (vga_out_clocked_video_vid_v),                     //                  .vid_v
		.main_clock_clk                (clk_clk),                                         //        main_clock.clk
		.main_reset_reset              (rst_controller_reset_out_reset),                  //        main_reset.reset
		.din_data                      (test_pattern_dout_data),                          //               din.data
		.din_valid                     (test_pattern_dout_valid),                         //                  .valid
		.din_startofpacket             (test_pattern_dout_startofpacket),                 //                  .startofpacket
		.din_endofpacket               (test_pattern_dout_endofpacket),                   //                  .endofpacket
		.din_ready                     (test_pattern_dout_ready),                         //                  .ready
		.control_address               (mm_interconnect_0_vga_out_control_address),       //           control.address
		.control_byteenable            (mm_interconnect_0_vga_out_control_byteenable),    //                  .byteenable
		.control_write                 (mm_interconnect_0_vga_out_control_write),         //                  .write
		.control_writedata             (mm_interconnect_0_vga_out_control_writedata),     //                  .writedata
		.control_read                  (mm_interconnect_0_vga_out_control_read),          //                  .read
		.control_readdata              (mm_interconnect_0_vga_out_control_readdata),      //                  .readdata
		.control_readdatavalid         (mm_interconnect_0_vga_out_control_readdatavalid), //                  .readdatavalid
		.control_waitrequest           (mm_interconnect_0_vga_out_control_waitrequest),   //                  .waitrequest
		.status_update_irq_irq         (irq_mapper_receiver2_irq)                         // status_update_irq.irq
	);

	new_core_mm_interconnect_0 mm_interconnect_0 (
		.clk_0_clk_clk                           (clk_clk),                                                   //                       clk_0_clk.clk
		.CPU_reset_reset_bridge_in_reset_reset   (rst_controller_reset_out_reset),                            // CPU_reset_reset_bridge_in_reset.reset
		.CPU_data_master_address                 (cpu_data_master_address),                                   //                 CPU_data_master.address
		.CPU_data_master_waitrequest             (cpu_data_master_waitrequest),                               //                                .waitrequest
		.CPU_data_master_byteenable              (cpu_data_master_byteenable),                                //                                .byteenable
		.CPU_data_master_read                    (cpu_data_master_read),                                      //                                .read
		.CPU_data_master_readdata                (cpu_data_master_readdata),                                  //                                .readdata
		.CPU_data_master_write                   (cpu_data_master_write),                                     //                                .write
		.CPU_data_master_writedata               (cpu_data_master_writedata),                                 //                                .writedata
		.CPU_data_master_debugaccess             (cpu_data_master_debugaccess),                               //                                .debugaccess
		.CPU_instruction_master_address          (cpu_instruction_master_address),                            //          CPU_instruction_master.address
		.CPU_instruction_master_waitrequest      (cpu_instruction_master_waitrequest),                        //                                .waitrequest
		.CPU_instruction_master_read             (cpu_instruction_master_read),                               //                                .read
		.CPU_instruction_master_readdata         (cpu_instruction_master_readdata),                           //                                .readdata
		.code_memory_s1_address                  (mm_interconnect_0_code_memory_s1_address),                  //                  code_memory_s1.address
		.code_memory_s1_write                    (mm_interconnect_0_code_memory_s1_write),                    //                                .write
		.code_memory_s1_readdata                 (mm_interconnect_0_code_memory_s1_readdata),                 //                                .readdata
		.code_memory_s1_writedata                (mm_interconnect_0_code_memory_s1_writedata),                //                                .writedata
		.code_memory_s1_byteenable               (mm_interconnect_0_code_memory_s1_byteenable),               //                                .byteenable
		.code_memory_s1_chipselect               (mm_interconnect_0_code_memory_s1_chipselect),               //                                .chipselect
		.code_memory_s1_clken                    (mm_interconnect_0_code_memory_s1_clken),                    //                                .clken
		.CPU_debug_mem_slave_address             (mm_interconnect_0_cpu_debug_mem_slave_address),             //             CPU_debug_mem_slave.address
		.CPU_debug_mem_slave_write               (mm_interconnect_0_cpu_debug_mem_slave_write),               //                                .write
		.CPU_debug_mem_slave_read                (mm_interconnect_0_cpu_debug_mem_slave_read),                //                                .read
		.CPU_debug_mem_slave_readdata            (mm_interconnect_0_cpu_debug_mem_slave_readdata),            //                                .readdata
		.CPU_debug_mem_slave_writedata           (mm_interconnect_0_cpu_debug_mem_slave_writedata),           //                                .writedata
		.CPU_debug_mem_slave_byteenable          (mm_interconnect_0_cpu_debug_mem_slave_byteenable),          //                                .byteenable
		.CPU_debug_mem_slave_waitrequest         (mm_interconnect_0_cpu_debug_mem_slave_waitrequest),         //                                .waitrequest
		.CPU_debug_mem_slave_debugaccess         (mm_interconnect_0_cpu_debug_mem_slave_debugaccess),         //                                .debugaccess
		.jtag_uart_avalon_jtag_slave_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //     jtag_uart_avalon_jtag_slave.address
		.jtag_uart_avalon_jtag_slave_write       (mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),       //                                .write
		.jtag_uart_avalon_jtag_slave_read        (mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),        //                                .read
		.jtag_uart_avalon_jtag_slave_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                                .readdata
		.jtag_uart_avalon_jtag_slave_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                                .writedata
		.jtag_uart_avalon_jtag_slave_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                                .waitrequest
		.jtag_uart_avalon_jtag_slave_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  //                                .chipselect
		.switches_s1_address                     (mm_interconnect_0_switches_s1_address),                     //                     switches_s1.address
		.switches_s1_readdata                    (mm_interconnect_0_switches_s1_readdata),                    //                                .readdata
		.sys_clk_timer_s1_address                (mm_interconnect_0_sys_clk_timer_s1_address),                //                sys_clk_timer_s1.address
		.sys_clk_timer_s1_write                  (mm_interconnect_0_sys_clk_timer_s1_write),                  //                                .write
		.sys_clk_timer_s1_readdata               (mm_interconnect_0_sys_clk_timer_s1_readdata),               //                                .readdata
		.sys_clk_timer_s1_writedata              (mm_interconnect_0_sys_clk_timer_s1_writedata),              //                                .writedata
		.sys_clk_timer_s1_chipselect             (mm_interconnect_0_sys_clk_timer_s1_chipselect),             //                                .chipselect
		.sysid_control_slave_address             (mm_interconnect_0_sysid_control_slave_address),             //             sysid_control_slave.address
		.sysid_control_slave_readdata            (mm_interconnect_0_sysid_control_slave_readdata),            //                                .readdata
		.test_pattern_control_address            (mm_interconnect_0_test_pattern_control_address),            //            test_pattern_control.address
		.test_pattern_control_write              (mm_interconnect_0_test_pattern_control_write),              //                                .write
		.test_pattern_control_read               (mm_interconnect_0_test_pattern_control_read),               //                                .read
		.test_pattern_control_readdata           (mm_interconnect_0_test_pattern_control_readdata),           //                                .readdata
		.test_pattern_control_writedata          (mm_interconnect_0_test_pattern_control_writedata),          //                                .writedata
		.test_pattern_control_byteenable         (mm_interconnect_0_test_pattern_control_byteenable),         //                                .byteenable
		.test_pattern_control_readdatavalid      (mm_interconnect_0_test_pattern_control_readdatavalid),      //                                .readdatavalid
		.test_pattern_control_waitrequest        (mm_interconnect_0_test_pattern_control_waitrequest),        //                                .waitrequest
		.vga_out_control_address                 (mm_interconnect_0_vga_out_control_address),                 //                 vga_out_control.address
		.vga_out_control_write                   (mm_interconnect_0_vga_out_control_write),                   //                                .write
		.vga_out_control_read                    (mm_interconnect_0_vga_out_control_read),                    //                                .read
		.vga_out_control_readdata                (mm_interconnect_0_vga_out_control_readdata),                //                                .readdata
		.vga_out_control_writedata               (mm_interconnect_0_vga_out_control_writedata),               //                                .writedata
		.vga_out_control_byteenable              (mm_interconnect_0_vga_out_control_byteenable),              //                                .byteenable
		.vga_out_control_readdatavalid           (mm_interconnect_0_vga_out_control_readdatavalid),           //                                .readdatavalid
		.vga_out_control_waitrequest             (mm_interconnect_0_vga_out_control_waitrequest)              //                                .waitrequest
	);

	new_core_irq_mapper irq_mapper (
		.clk           (clk_clk),                        //       clk.clk
		.reset         (rst_controller_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),       // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),       // receiver1.irq
		.receiver2_irq (irq_mapper_receiver2_irq),       // receiver2.irq
		.sender_irq    (cpu_irq_irq)                     //    sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_reset_n),                     // reset_in0.reset
		.clk            (clk_clk),                            //       clk.clk
		.reset_out      (rst_controller_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_in1      (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

endmodule
